import com.fasterxml.jackson.databind.ObjectMapper;
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.JsonNode;
import com.mashape.unirest.http.Unirest;
import com.mashape.unirest.http.exceptions.UnirestException;
import com.mashape.unirest.request.GetRequest;
import org.json.JSONArray;
import org.json.JSONObject;

import java.util.Scanner;

public class YouAreEll {

    YouAreEll() {
    }

    public static void main(String[] args) {
        YouAreEll url = new YouAreEll();

        boolean flag = true;
        while (flag) {
            String userChoice = Console.printMainMenu();
            switch (userChoice) {
                case "GET":
                    url.sendGetIDsRequest(url);
                    Console.printSuccess(userChoice);
                    break;
                case "ADD":
                    url.sendInputUserInfoRequest(url);
                    Console.printSuccess(userChoice);
                    break;
                case "SEND":
                    url.sendMenu(Console.printSendMenu(), url);
                    Console.printSuccess(userChoice);
                    break;
                case "SEE":
                    url.sendGetGlobalMessagesRequest(url);
                    Console.printSuccess(userChoice);
                    break;
                case "QUIT":
                    flag = false;
                    break;
                default:
                    Console.printError();
                    break;
            }
        }
//        url.sendInputUserInfoRequest(url);
    }

    public String get_ids() {
        return MakeURLCall("/ids", "GET", "");
    }

    public String get_messages() {
        return MakeURLCall("/messages", "GET", "");
    }

    public String MakeURLCall(String mainurl, String method, String jpayload) {
        return "nada";
    }

    public String getInput(String input) {
        return input;
    }

    public void sendMenu(String sendOption, YouAreEll url) {
        switch (sendOption) {
            case "GLOBAL":
                url.sendGlobalMessageRequest(url);
                break;
            case "DIRECT":
                url.sendDirectMessageRequest(url);
                break;
            default:
                break;
        }
    }

    public void inputUserInfo() throws UnirestException {
        String name = getInput(Console.getName());
        String github = getInput(Console.getGithub());
        HttpResponse<JsonNode> jsonResponse = Unirest.post("http://zipcode.rocks:8085/ids")
                //.header("accept", "application/json")
                .body("{\"userid\": \"\"," +
                        "\n\"name\": \"" + name + "\"," +
                        "\n\"github\": \"" + github + "\"}")
                .asJson();
        jsonResponse.getStatus();
    }

    public void inputGlobalMessage() throws UnirestException {
        String fromID = getInput(Console.getFromID());
        String message = getInput(Console.getMessage());
        HttpResponse<JsonNode> jsonResponse = Unirest.post("http://zipcode.rocks:8085/ids/mygithubid/messages")
                // .header("accept", "application/json")
                .body("{\"fromid\": \"" + fromID + "\"," +
                        "\n\"toid\": \"\"," +
                        "\n\"message\": \"" + message + "\"}")
                .asJson();
        jsonResponse.getStatus();
    }

    public void inputDirectMessage() throws UnirestException {
        String fromID = getInput(Console.getFromID());
        String toID = getInput(Console.getToID());
        String message = getInput(Console.getMessage());
        HttpResponse<JsonNode> jsonResponse = Unirest.post("http://zipcode.rocks:8085/ids/" + toID + "/messages")
                //.header("accept", "application/json")
                .body("{\"fromid\": \"" + fromID + "\"," +
                        "\n\"toid\": \"" + toID + "\"," +
                        "\n\"message\": \"" + message + "\"}")
                .asJson();
        jsonResponse.getStatus();
    }

    public void getAllUserIDs() throws UnirestException {
        HttpResponse<JsonNode> jsonResponse = Unirest.get("http://zipcode.rocks:8085/ids")
                // .header("accept", "application/json")
                .asJson();
        jsonResponse.getBody();
        System.out.println(jsonResponse.getBody());
    }

    public void getGlobalMessages() throws UnirestException {
        HttpResponse<JsonNode> jsonResponse = Unirest.get("http://zipcode.rocks:8085/messages")
                // .header("accept", "application/json")
                .asJson();
        jsonResponse.getBody();
        System.out.println(jsonResponse.getBody());
        // jackson --> pretty print
    }

    public void sendGetGlobalMessagesRequest(YouAreEll url) {
        try {
            url.getGlobalMessages();
        } catch (UnirestException u) {
            System.out.println("Error getting global messages.");
        }
    }

    public void sendGlobalMessageRequest(YouAreEll url) {
        try {
            url.inputGlobalMessage();
        } catch (UnirestException u) {
            System.out.println("Error sending global message.");
        }
    }

    public void sendDirectMessageRequest(YouAreEll url) {
        try {
            url.inputDirectMessage();
        } catch (UnirestException u) {
            System.out.println("Error sending direct message.");
        }
    }

    public void sendInputUserInfoRequest(YouAreEll url) {
        try {
            url.inputUserInfo();
        } catch (UnirestException u) {
            System.out.println("Error inputting user info.");
        }
    }

    public void sendGetIDsRequest(YouAreEll url) {
        try {
            url.getAllUserIDs();
        } catch (UnirestException u) {
            System.out.println("Error getting user IDs.");
        }
    }
}
